--[[====================Pause Mod======================
	Scripter:[TW2D]Razgriz
	Latest Update Time:6/13/2011
	Version: 1.1
	=====================Update At=====================
	http://www.unrealsoftware.de/files_show.php?file=7042
]]
pausemod={
	pause_in_zombie=false,		--Can you pause the game in zombie mode?
	
	array=function(m,n) local Array = {} for i = 1, m do Array[i] = n end return Array end,
	c=string.char(169),
	mode=tonumber(game("sv_gamemode")),
}
pausemod.paused=pausemod.array(32,false)
pausemod.team=pausemod.array(32,"Choose your team first! LOL")
pausemod.image=pausemod.array(32,true)
pausemod.delay=pausemod.array(32,0)

addhook("join","pausemod.join")
addhook("say","pausemod.say")
addhook("hit","pausemod.hit")
addhook("team","pausemod.teamup")
addhook("startround","pausemod.startrnd")
addhook("second","pausemod.second")
addhook("buildattempt","pausemod.whenbuild")

parse("mp_idlekick 0")

function pausemod.message(id,state)
	if not state then state=1 end
	local name=player(id,"name")

	if state==1 then
		msg(pausemod.c.."175175175("..pausemod.team[id]..")"..name.." has paused.")
		msg2(id,pausemod.c.."255255255You have 10 seconds cool-down before you can unpause again.")
		msg(pausemod.c.."000255128Say \"!pause\" to pause your game!")
		pausemod.delay[id]=10
	elseif state==2 then
		msg(pausemod.c.."175175175("..pausemod.team[id]..")"..name.." has unpaused.")
		msg2(id,pausemod.c.."255255255You have 10 seconds cool-down before you can pause again.")
		msg(pausemod.c.."000255128Say \"!pause\" to pause your game!")
		pausemod.delay[id]=10
	end
end

function pausemod.say(id,txt)
	if txt=="!pause" and player(id,"health")>0 then
		if pausemod.delay[id]==0 then
			if pausemod.paused[id]==false then
				if pausemod.mode==4 and pausemod.pause_in_zombie==false then
					msg2(id,pausemod.c.."255000000You can't pause in zombie mode!@C")
				else
					pausemod.message(id,1)
					pausemod.paused[id]=true
					parse("speedmod "..id.." -100")
					pausemod.image[id]=image("gfx/paused.png",0,0,id+200)
					pausemod.onlyknife(id)
				end
			elseif pausemod.paused[id] then
				pausemod.message(id,2)
				pausemod.paused[id]=false
				parse("speedmod "..id.." 0")
				freeimage(pausemod.image[id])
			end
		elseif pausemod.delay[id]>0 then
			msg2(id,pausemod.c.."255255255You still have "..pausemod.delay[id].." seconds cool-down time!")
		end
		return 1
	elseif txt=="!pause" and player(id,"health")<1 then
		msg2(id,pausemod.c.."255000000You are dead so you don't need to pause the game!")
		return 1
	end
end

function pausemod.join(id)
	pausemod.paused[id]=false
	pausemod.team[id]="Choose your team first! LOL"
	pausemod.delay[id]=0
	if pausemod.image[id]~=true then
		freeimage(pausemod.image[id])
	end
end

function pausemod.teamup(id,team)
	if team==2 then
		pausemod.team[id]="CT"
	elseif team==1 then
		pausemod.team[id]="TT"
	end
	if pausemod.image[id]~=true then
		freeimage(pausemod.image[id])
	end
	pausemod.paused[id]=false
	pausemod.delay[id]=0
end

function pausemod.hit(id,source)
	if pausemod.paused[id] or pausemod.paused[source] then
		return 1
	end
end

function pausemod.startrnd()
	for i in ipairs(player(0,"table")) do
		if pausemod.paused[i]==true then
			parse("speedmod "..i.." -100")
			pausemod.image[i]=image("gfx/paused.png",0,0,i+200)
			pausemod.onlyknife(i)
		end
	end
	pausemod.mode=tonumber(game("sv_gamemode"))
end

function pausemod.second()
	for i in ipairs(player(0,"table")) do
		if pausemod.delay[i]~=0 then pausemod.delay[i]=pausemod.delay[i]-1 end
	end
end

function pausemod.whenbuild(id)
	if pausemod.paused[id] then
		msg2(id,pausemod.c.."255000000You are unable to build when paused!@C")
		return 1
	end
end

function pausemod.onlyknife(id)
	if pausemod.paused[id] then
		parse("setweapon "..id.." 74")
		parse("setweapon "..id.." 50")
	end
end

function pausemod.objdmg(objid,damage,id)
	if pausemod.paused[id] then
		return 1
	end
end